//
// Created by 11067 on 2023/7/8.
//

#ifndef COMPILER_LIVEINFO_H
#define COMPILER_LIVEINFO_H

#include "APass.h"
#include "../../../utils/Bitset.h"
#include <unordered_map>
#include <unordered_set>
#include <bitset>
namespace armv7 {

    class LiveInfo: APass {
        std::unordered_map<ABlock *, atri::Bitset> def{};
        std::unordered_map<ABlock *, atri::Bitset> use{};
        std::unordered_map<ABlock *, atri::Bitset> liveIn{};
        std::unordered_map<ABlock *, atri::Bitset> liveOut{};
        std::unordered_set<ABlock*> visited{};
        std::vector<AReg> int2reg{};
        int regsCnt{0};
        bool changed = false; //是否变化，此算法终止条件是迭代到不动点
        void walkABlock(ABlock *nw);
    public:
        void run(ACompileUnit &compileUnit) override;
        void runOnFunction(AFunction * function);

        void calcuABlock(ABlock *nw);
    };

} // armv7

#endif //COMPILER_LIVEINFO_H
