//
// Created by 11067 on 2023/7/30.
//

#ifndef COMPILER_MERGEBLOCK_H
#define COMPILER_MERGEBLOCK_H

#include "APass.h"

namespace armv7 {

    class MergeBlock : public APass{
        void mergeSinglePath(AFunction *function);
        /**
         * 拆分关键边会生成多余的空块
         * @param function
         */
        void mergeJump(AFunction *function);
        ABlock* combineMultiJump(ABlock* srcBlock, ABlock *block);
    public:
        void run(ACompileUnit &compileUnit) override;
    };

} // armv7

#endif //COMPILER_MERGEBLOCK_H
