1. RISCV的ori是符号扩展
2. RISCV的lui加载高20位，相应的，立即数是12位。
3. 加载64位Int可以lui，ori，逻辑左移，然后再加载低32位；不过更常用的方法是从常量池加载（不过我们也不支持64位整型）。
4. *w后缀表示指令只操作低32位，我们大概只用这些指令
5. riscv没有J，但是JAL可以指定一个寄存器参数，于是用jal zero,label 表示j。jal貌似有一些复杂的行为被用于支持协程。
6. riscv的mul和div都是标准的R型指令（没有mfhi，mflo），如果是同时取余数和商，优化（fuse）的操作被交给微架构，推荐先div
    再rem。
## 指令类型

序号	指令类型	作用
1.	R 型指令	用于寄存器和寄存器操作
2.	I 型指令	用于短立即数和内存载入指令load操作，12位立即数
3.	S 型指令	用于内存存储store操作，12位立即数
4.	B 型指令	用于有条件跳转操作
5.	U 型指令	用于长立即数操作，20位立即数
6.	J 型指令	用于无条件跳转操作

## 浮点运算

1. RISCV浮点运算有dyn位用于指定摄入模式，也可以用状态寄存器指定，C没有规定死摄入模式，可以
有一个宏调整。

## 函数调用

1. 伪指令call会被编译为auipc和jalr，用于支持长跳转，一般的jal只有20位寻址，jalr是
I型指令，RISCV的j被编码为jalr(rd=x0)