//
// Created by MSI-NB on 2023/7/11.
//

#include "MPseudoInstr.h"
namespace riscv {
PhiInstr::PhiInstr(const Reg &dest) { op1 = dest; }

void riscv::ParaCopyInstr::gen_asm(std::ostream &out) { out << "para copy\n"; }
void riscv::PhiInstr::gen_asm(std::ostream &out) {
  out << "phi " << op1 << "\n";
}

void DebugInstr::gen_asm(std::ostream &out) {
  out << "#debugging" << out_info << "\n";
}
} // namespace riscv
