## CRTP
```c++
template <typename T>
struct Base {
    void foo() {
       T & derived =  static_cast<T&>(* this);
       derived.foo();
    }
};
struct A : Base<A> {
    void foo() {
        cout << "this is A" << endl;
    }
};
struct B : Base<B> {
    int x;
    B(int _x) :x{ _x } {};
    void foo() {
        cout << "this is B :"<< x << endl;
    }
};
int main() {
    Base<A>* p1 = new A{};
    p1->foo();
    Base<B>* p2 = new B{114};
    p2->foo();
    p2 = new B{ 514 };
    p2->foo();
}
```
CPP编译期多态，想念Rust。

在CPP中hack各种奇怪的特性实现需要的功能为啥不用Rust。

LinkedList链表容器使用了这个技术。

## pimpl
Pimpl(Pointer to implementation) 是一种减少代码依赖和编译时间的C++编程技巧，
其基本思想是将一个外部可见类(visible class)的实现细节
（一般是所有私有的非虚成员）放在一个单独的实现类(implementation class)中，
而在可见类中通过一个私有指针来间接访问该实现类。