//
// Created by 11067 on 2023/5/22.
//

#include "MCData.h"

namespace riscv {

MCData * makeMCDataFloat(const std::string& label, const std::vector<float>& array) {
    FloatOrZero arr = std::vector<float>{array};
    return new MCData{label, std::vector<FloatOrZero>{arr}};
}

MCData * makeMCDataInt(const std::string& label, const std::vector<int>& array) {
    IntOrZero arr = std::vector<int>{array};
    return new MCData{label,std::vector<IntOrZero>{arr}};
}


MCData *makeMCDataFloatZeroed(const std::string &label, int s) {
    FloatOrZero arr = s;
    return new MCData{label, std::vector<FloatOrZero>{arr}};
}

MCData *makeMCDataIntZeroed(const std::string &label, int s) {
    IntOrZero arr = s;
    return new MCData{label, std::vector<IntOrZero>{arr}};
}
} // riscv