//
// Created by 11069 on 3/7/2023.
//

#ifndef COMPILER_CFG_H
#define COMPILER_CFG_H
#include<memory>
#include "ir.h"
using namespace std;
namespace opt {
class CFG {
    // control flow graph builder
    // compute bbs relation and dom
private:

    Ir::Function *func;
    void dom_level_compute(Ir::BasicBlock * root,int level);
public:
    explicit CFG(Ir::Function * _func);
    void build(); // build cfg
    void dom_build(); // build dom
    void loop_analysis();

};


} // namespace opt

#endif // COMPILER_CFG_H
