//
// Created by 11069 on 4/8/2023.
//
#include "opt.h"
using namespace Ir;

namespace opt {
  void rebuild_use_def(CompileUnit* compileUnit) {
    for(auto &func:compileUnit->get_functions()) {
      if(func->is_lib()) {
        continue ;
      }
      func->use_place.clear();
      func->def_place.clear();
      for(auto &bb:func->get_bbs()) {
        for(auto &inst:bb->get_instrs()) {
            inst->add_use_def();
        }
      }
    }

  }
}